﻿namespace Scan_Measurement_Example
{
    public class AdvancedMeasurementSettings
    {
        private double m_resBW;
        private double m_measTime;
        private double m_rfAttn;

        private DetectorType m_detectorType;

        public AdvancedMeasurementSettings()
        {

        }

        ~AdvancedMeasurementSettings()
        {

        }

        public virtual void Dispose()
        {

        }

        public DetectorType getDetectorType()
        {
            return this.m_detectorType;
        }

        public void setDetectorType(int detectorType)
        {
            if (detectorType == 0)  // Max Peak
            {
                this.m_detectorType = DetectorType.m_maxPeak;
            }
            else if (detectorType == 1)  // Min Peak
            {
                this.m_detectorType = DetectorType.m_minPeak;
            }
            else if (detectorType == 2) // Average
            {
                this.m_detectorType = DetectorType.m_average;
            }
            else if (detectorType == 3)  // RMS
            {
                this.m_detectorType = DetectorType.m_rms;
            }
            else if (detectorType == 4)  // QPeak
            {
                this.m_detectorType = DetectorType.m_quasipeak;
            }
            else if (detectorType == 5)  // CRMS
            {
                this.m_detectorType = DetectorType.m_cisprRMS;
            }
            else if (detectorType == 6)  // CAverage
            {
                this.m_detectorType = DetectorType.m_average;
            }
        }

        public double getResBW()
        {
            return this.m_resBW;
        }

        public void setResBW(double resBW)
        {
            this.m_resBW = resBW;
        }

        public double getMeasTime()
        {
            return this.m_measTime;
        }

        public void setMeasTime(double measTime)
        {
            this.m_measTime = measTime;
        }

        public double getRfAttn()
        {
            return this.m_rfAttn;
        }

        public void setRfAttn(double rfAttn)
        {
            this.m_rfAttn = rfAttn;
        }
    }
}