namespace Scan_Measurement_Example
{
    public class SettingsManager
    {
        public RemoteControlSettings m_remoteControlSetting;
        public MeasurementSettings m_measurementSettings;
        public AdvancedMeasurementSettings m_advancedMeasruementSettings;
        public PeakSearchSettings m_peakSearchSettings;

        public SettingsManager()
        {
            m_remoteControlSetting = new RemoteControlSettings();
            m_measurementSettings = new MeasurementSettings();
            m_advancedMeasruementSettings = new AdvancedMeasurementSettings();
            m_peakSearchSettings = new PeakSearchSettings();
        }

        ~SettingsManager()
        {

        }

        public void setRemoteControlSettings(int instrumentModel, string resourceDescriptor, bool idQuery, bool resetDevice, bool displayEnable)
        {
            m_remoteControlSetting.setInstrumentType(instrumentModel);
            m_remoteControlSetting.setResourceDescriptor(resourceDescriptor);
            m_remoteControlSetting.setIdQuery(idQuery);
            m_remoteControlSetting.setResetDevice(resetDevice);
            m_remoteControlSetting.setDisplayEnable(displayEnable);
        }

        public void setMeasurementSettings(double startFreq, double stopFreq, int stepMode, double stepSize)
        {
            m_measurementSettings.setStartFrequency(startFreq);
            m_measurementSettings.setStopFrequency(stopFreq);
            m_measurementSettings.setStepMode(stepMode);
            m_measurementSettings.setStepSize(stepSize);
        }

        public void setAdvancedMeasurementSettings(int detector, double resBW, double measTime, double rfAttn)
        {
            m_advancedMeasruementSettings.setDetectorType(detector);
            m_advancedMeasruementSettings.setResBW(resBW);
            m_advancedMeasruementSettings.setMeasTime(measTime);
            m_advancedMeasruementSettings.setRfAttn(rfAttn);
        }

        public void setPeakSearchSettings(bool methodPeaks, bool methodSubranges, int numberOfPeaksSubranges)
        {
            m_peakSearchSettings.setPeakSearchMethod(methodPeaks, methodSubranges);
            m_peakSearchSettings.setNumberOfPeaksSubranges(numberOfPeaksSubranges);
        }
    }
}